=== debian/changelog ===
pakcs (1.14.1-4) unstable; urgency=medium

  * debian/rules:
    + Don't run unit tests on 32bit hardware. The SWI-Prolog's stack size is to
      small for it on 32bit platforms.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 08 Feb 2017 17:18:04 +0100

pakcs (1.14.1-3) unstable; urgency=medium

  * debian/patches:
    + Add 0055-More-error-exit-codes-are-set.patch,
          0056-CASS-tool-updated-containing-new-analyses.patch,
          0057-Makefiloe-changed-for-package-installation-verbose-m.patch,
          0058-Tools-and-libs-updated.patch.
      Add more exit points with exit code.
      Support running tests in verbose mode.
    + Add 0059-lockfile-command-replaced-by-lockfile-create-remove.patch;
      use lockfile-progs instead of procmail's lockfile.
    + Add 0060-Bug-for-loading-libraries-with-SWI-Prolog-fixed-SWI-.patch,
      0061-Release-notes-and-build-version-number-adapted.patch; fix library
      loading issue with SWI Prolog.
    + Add 0062-tools-and-libs-updated.patch,
          0063-Check-for-existence-of-home-directory-extended.patch,
          0064-tools-updated.patch.
      Check existence of home directory + release notes updates.
    + Add 0065-tools-updated-clean-up-after-runtest-added-in-Makefi.patch,
          0066-noreadline-added-to-CHR-tests.patch,
          0067-pakcs-script-slightly-improved-w.r.t-home-dir-checki.patch.
      Prevent test suite from attempting to create non-existent home directory.
  * debian/control:
    + Add to B-D and R (pakcs): sqlite3. Test suite also tests some database
      functionalities based on SQLite 3. Same functionalities at runtime are
      only available if SQLite 3 is installed.
    + Update versioned B-D for curry-libs and curry-tools. Various fixes for
      the test runs shipped in those new package revisions.
    + Add to B-D and D (pakcs): lockfile-progs. Required by IOExts in curry-libs.
    + Typo fix in package SYNOPSIS. (Closes: #852950).
    + Add to S (pakcs): tk.
  * debian/rules:
    + Enable unit tests (via runtestverbose CHECK target).
    + Make sure that cleancurry is available via PAKCSHOME/bin at build time.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 03 Feb 2017 09:22:38 +0100

pakcs (1.14.1-2) unstable; urgency=medium

  * debian/control:
    + With curry-base 0.4.2-3 we don't need to enforce UTF-8 locale anymore. Now
      enforced in the curry-base code directly.
    + Version-bump B-Ds for curry-libs and curry-tools to 1.0.1. Required for
      new PAKCSINSTALLDIR handling.
    + Add D (pakcs): swi-prolog-nox (>= 7.2.3).
    + Update versioned B-D / D on curry-frontend. Make sure that 0.4.2-2~ or
      higher is installed, to assure having the UTF-8 fix on board.
    + Make package team-maintained (Debian Curry Maintainers, pkg-curry team on
      Alioth). Move myself to Uploaders: field. Add Michael Hanus (upstream) to
      Uploaders: field.
  * debian/rules:
    + Use cleanall target for upstream clean-up.
    + Additionally clean-up bin/, currytools/, debian/build/ and
      scripts/makesavedstate on clean target.
    + Set PAKCSINSTALLDIR and hand it over to upstream Makefile's build target.
    + Remove commented out DEB_MAKE_INSTALL_TARGET. Disable
      DEB_MAKE_CHECK_TARGET for now; it consumes a lot of time, memory and
      generates no output.
  * debian/patches:
    + Cherry-pick 0044-Addition-of-constant-for-package-install-dir-added.patch,
      0045-Installation-extended-to-PAKCSINSTALLDIR.patch,
      0048-Tools-update.patch, 0049-Tools-update.patch and
      0050-References-to-cymake-replaced-by-pakcs-frontend.patch from upstream.
      Adds PAKCSINSTALLDIR variable support to pakcs's main Makefile.
    + Drop unused patch file 0027-libs-updated.patch.
    + Add 0051-Prolog-module-imports-changed-to-avoid-SWI-errors.patch
      0052-pakcs-cymake-occurrence-removed.patch
      0053-SICStus-compilation-adapted-to-new-scheme-for-SWI-Pr.patch
      0054-Fix-for-loading-run-time-libraries-in-SICStus-back-e.patch
      (cherry-picked from upstream). Fix module loading in SWI Prolog.
    + Update 2001_run-cleancurry-from-inside-debian-subfolder.patch.
  * debian/pakcs.{install,links}:
    + Drop work-around for broken symlinks. Upstream now has relative symlinks.
  * debian/copyright:
    + Update copyright attributions.
  * debian/pakcs.lintian-overrides:
    + Fix typo in override comment.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 27 Jan 2017 14:23:32 +0100

pakcs (1.14.1-1) unstable; urgency=low

  * Initial release to Debian. (Closes: #840519).

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 23 Dec 2016 16:49:39 +0100
